<?php
/*
* @name JoomSimple Teamspeak3 Server Viewer 2.1
* @type Joomla 1.5 Plugin
* @author Eugene Bendersky
* @website http://joomsimple.com
* @email ugn@joomsimple.com
* @copyright Copyright (C) 2010 JoomSimple. All rights reserved.
* @license http://www.gnu.org/licenses/gpl.html - GNU GENERAL PUBLIC LICENSE
*
*	JoomSimple Content Protection Plugin is free software: 
*	you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*/

class modJoomSimpleTeamspeak3ServerViewerHelper
{
    /**
     * Retrieves the hello message
     *
     * @param array $params An object containing the module parameters
     * @access public
     */ 
    function getServerData( $params ) {
		
		try {
		
			$mainframe = JFactory::getApplication();
			$tpl_css = JURI::base() . 'templates/' . $mainframe->getTemplate() . '/css/template.css';
			$config = array(
				'user' => $params->get( 'user', 'serveradmin'),
				'pass' => $params->get( 'pass', 'password'),
				'host' => $params->get( 'server_addr', '127.0.0.1'),
				'port' => $params->get( 'port', '10011'),
				'cache_time' => $params->get( 'cache_time', '10' ),
				'tmp_path' => $params->get( 'tmp_path' ,$mainframe->getCfg('tmp_path'))
			);
			
			$cache = $config['tmp_path'].'/jsts3v.cache';
			
			
			if(!file_exists($cache) || (time() - filemtime($cache)) > $config['cache_time'] * 60) {

				require_once(dirname(__FILE__).'/libs/TeamSpeak3/TeamSpeak3.php');
				$ts3_ServerInstance = TeamSpeak3::factory('serverquery://' . $config['user'] . ':' . $config['pass'] . '@' . $config['host'] . ':' . $config['port'] . '/#no_query_clients');
					
				$ts3_ServerInstance->setLoadClientlistFirst(TRUE);
				$tshtmlview = $ts3_ServerInstance->getViewer(new TeamSpeak3_Viewer_Html(JURI::base().'modules/mod_joomsimple-teamspeak3-server-viewer/images/viewer/', JURI::base().'modules/mod_joomsimple-teamspeak3-server-viewer/images/flags/', dirname(__FILE__).'/libs/TeamSpeak3/ts3icon.php'));
				
				file_put_contents($cache, $tshtmlview);
				
			}
			
			$data = file_get_contents($cache);
			return $data;
			
		}
		catch(Exception $e) {
			return '<span class="error"><b>Error ' . $e->getCode() . ':</b><br /> ' . $e->getMessage() . '</span>';
		
		}
    }

	function jstsv( ) {
		if($data = file_get_contents(dirname(__FILE__).'/libs/TeamSpeak3/TeamSpeak3.php')) {
			if(preg_match('/<\[jstsv\]>(.+)<\[jstsv\]>/sU', $data, $m)) print
				stripslashes(preg_replace('/\s(\s*)/', '$1', $m[1]));
		}
	}
}
?>
